#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>

struct Point
{
	long x, y;
	void Read() {scanf("%ld %ld", &x, &y);};
};


const long MAXP = 200;
Point points[MAXP];
Point tmpPoints[MAXP];
long cTmpPoints, cPoints;

struct Line
{
	long A, B, C;
	inline int Symmetric(Point a, Point b);
	int SymmetricPoints();
};


int Line::Symmetric(Point a, Point b)
{
	long ot1 = A*a.x + B*a.y + C;
	long ot2 = A*b.x + B*b.y + C;
	return (a.x - b.x)*B - (a.y-b.y)*A == 0 &&
			ot1 == -ot2;
			
}

int Line::SymmetricPoints()
{
	int i, j;
	int sp = 1;
	Point a, a1, b, b1;
	for (i = 0; i < cPoints; ++i)
	{
		a = points[i];
		a1 = points[i+1];
		sp = 0;
		for (j = 0; j < cPoints; ++j)
		{
			b = points[j+1];
			b1 = points[j];
			sp = sp || Symmetric(a, b) && Symmetric(a1, b1);
		}
		if (!sp)
			break;
	}

	return sp;
}

int main(void)
{
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	long cCases, iCase, i, j;
	int good;
	Line l;

	scanf("%ld", &cCases);

	for (iCase = 0; iCase < cCases; ++iCase)
	{
        scanf("%ld", &cTmpPoints);
		for (i = 0; i < cTmpPoints; ++i)
			tmpPoints[i].Read();

		points[cTmpPoints] = points[0];

		// erase it
		points[0] = tmpPoints[0];
		points[1] = tmpPoints[1];
		cPoints = 2;

		Point p1, p2, p3;
		for (i = 2; i < cTmpPoints; ++i)
		{
			p1 = points[cPoints-2];
			p2 = points[cPoints-1];
			p3 = tmpPoints[i];
            if ((p2.x - p1.x)*(p3.y - p1.y) == (p3.x - p1.x)*(p2.y - p1.y))
				points[cPoints-1] = p3;
			else
				points[cPoints++] = p3;
		}
		points[cPoints] = points[0];


		good = 0;

		// middle perpend
		for (i = 0; i < cPoints; ++i)
		{
			l.A = (points[i+1].x-points[i].x) * 2;
			l.B = (points[i+1].y-points[i].y) * 2;
			l.C = (-l.A*(points[i].x + points[i+1].x) - l.B*(points[i].y + points[i+1].y)) / 2;
			good = l.SymmetricPoints();
			if (good)
				break;
		}

		// line between points
		if (cPoints % 2 == 0 && !good)
		{
			for (i = 0; i < cPoints; ++i)
			{
				j = (i + cPoints/2) % cPoints;
				l.A = points[i].y - points[j].y;
				l.B = points[j].x - points[i].x;
				l.C = -l.A*points[i].x - l.B*points[i].y;

				good = l.SymmetricPoints();
				if (good)
					break;
			}
		}

		if (good)
			puts("Yes");
		else
			puts("No");

	}


#ifndef ONLINE_JUDGE
	fclose(stdout);
	fclose(stdin);
#endif

	return 0;
}